//===========================================================================
// some utilities

char *strcpy_max(char *dest, const char *src, int maxlen)
{
	int n = strlen(src);
	if (n >= maxlen) n = maxlen-1;
	memcpy(dest, src, n);
	dest[n] = 0;
	return dest;
}

//===========================================================================
// Function: arrow_bullet
// Purpose:  draw the triangle bullet
// In:       HDC, position x,y, direction -1 or 1
// Out:
//===========================================================================

bool pSettings_arrowUnix;

void arrow_bullet (HDC buf, int x, int y, int d)
{
	int s = pSettings_bulletUnix ? 1 : 2; int e = d;

	if (pSettings_arrowUnix)
		x-= d*s, d+=d, e = 0;
	else
		s++, x -= d*s/2, d = 0;

	for (int i=-s, j=0; i<=s; i++)
	{
		j+=d;
		MoveToEx(buf, x,   y+i, NULL);
		j+=e;
		LineTo  (buf, x+j, y+i);
		if (0==i) d=-d, e=-e;
	}
}

//===========================================================================
// Function: get_fontheight
//===========================================================================
int get_fontheight(HFONT hFont)
{
	TEXTMETRIC TXM;
	HDC hdc = CreateCompatibleDC(NULL);
	HGDIOBJ other = SelectObject(hdc, hFont);
	GetTextMetrics(hdc, &TXM);
	SelectObject(hdc, other);
	DeleteDC(hdc);
	return TXM.tmHeight;// - TXM.tmInternalLeading - TXM.tmExternalLeading;
}

//===========================================================================

void dbg_printf (const char *fmt, ...)
{
	char buffer[256]; va_list arg;
	va_start(arg, fmt);
	vsprintf (buffer, fmt, arg);
	strcat(buffer, "\n");
	OutputDebugString(buffer);
}

//===========================================================================

#if 1
void EnumTasks (TASKENUMPROC lpEnumFunc, LPARAM lParam)
{
	struct tasklist *tl;
	dolist (tl, GetTaskListPtr())
		if (FALSE == lpEnumFunc(tl, lParam))
			break;
}
#endif

#if 0
void EnumTray (TRAYENUMPROC lpEnumFunc, LPARAM lParam)
{
	for (int i = 0, s = GetTraySize(); i < s; i++)
		if (FALSE == lpEnumFunc(GetTrayIcon(i), lParam))
			break;
}

void EnumDesks (DESKENUMPROC lpEnumFunc, LPARAM lParam)
{
	DesktopInfo info;
	GetDesktopInfo(&info);
	string_node *p = info.deskNames;
	for (int n = 0; n < info.ScreensX; n++)
	{
		DesktopInfo DI;
		DI.number = n;
		DI.deskNames = info.deskNames;
		DI.isCurrent = n == info.number;
		DI.name[0] = 0;
		if (p) strcpy(DI.name, p->str), p = p->next;

		if (FALSE == lpEnumFunc(&DI, lParam))
			break;
	}
}

#endif

IconList *add_list(IconList *icolst, systemTray* icon)
{
	IconList *newlist = new IconList;
	newlist->icon = icon;
	newlist->next = icolst;
	return newlist;
}

IconList *del_list(IconList *icolst, systemTray* icon)
{
	IconList *p, *tmp;
	p = tmp = icolst;
	if (icolst == NULL) return icolst;
	while (p->icon == icon){
		if (p->next == NULL){
			delete p;
			p->next = NULL;
			return NULL;
		}
		tmp = p->next;
		delete p;
		icolst = p = tmp;
	}
	while (p->next){
		while (p->next->icon == icon){
			if (p->next->next == NULL){
				delete p->next;
				p->next = NULL;
				return icolst;
			}
			tmp = p->next->next;
			delete p->next;
			p->next = tmp;
		}
		p = p->next;
	}
	
	return icolst;
}

bool find_list(IconList *icolst, systemTray* icon)
{
	while (icolst) {
		if (icolst->icon == icon) return true;
		icolst = icolst->next;
	}
	return false;
}

IconList *free_list(IconList *icolst)
{
	IconList *tmp;
	while (icolst) {
		tmp = icolst->next;
		delete icolst;
		icolst = tmp;
	}
	return icolst;
}

int GetListSize(IconList *icolst)
{
	int num = 0;
	while (icolst) {
		icolst = icolst->next;
		++num;
	}
	return num;
}	

#include <psapi.h>
#include <tlhelp32.h>
//
// EBhEnhÃW[̃tpX擾܂B
//
// p[^
//      hWnd
//          ׂEBhẼnh
//      lpszFileName
//          W[̊SCpX󂯎obt@ւ̃|C^
//      nSize
//          擾̍ő̒
//
// ߂l
//      ɃEBhE쐬W[̃tpX擾ł
//       TRUE Ԃ܂BȊO FALSE Ԃ܂B
//
BOOL GetFileNameFromHwnd(HWND hWnd, LPTSTR lpszFileName, DWORD nSize)
{
    BOOL bResult = FALSE;
    // EBhE쐬vZX ID 擾
    DWORD dwProcessId;
    GetWindowThreadProcessId(hWnd , &dwProcessId);

    // ݎsĂ OS ̃o[W擾
    OSVERSIONINFO osverinfo;
    osverinfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    if ( !GetVersionEx(&osverinfo) )
        return FALSE;

    // vbgtH[ Windows NT/2000 ̏ꍇ
    if ( osverinfo.dwPlatformId == VER_PLATFORM_WIN32_NT )
    {
        // PSAPI ֐̃|C^
        BOOL (WINAPI *lpfEnumProcessModules)
                            (HANDLE, HMODULE*, DWORD, LPDWORD);
        DWORD (WINAPI *lpfGetModuleFileNameEx)
                            (HANDLE, HMODULE, LPTSTR, DWORD);

        // PSAPI.DLL Cu[h
        HINSTANCE hInstLib = LoadLibrary("PSAPI.DLL");
        if ( hInstLib == NULL )
            return FALSE ;

        // vV[W̃AhX擾
        lpfEnumProcessModules = (BOOL(WINAPI *)
            (HANDLE, HMODULE *, DWORD, LPDWORD))GetProcAddress(
                        hInstLib, "EnumProcessModules");
        lpfGetModuleFileNameEx =(DWORD (WINAPI *)
            (HANDLE, HMODULE, LPTSTR, DWORD))GetProcAddress(
                        hInstLib, "GetModuleFileNameExA");

        if ( lpfEnumProcessModules && lpfGetModuleFileNameEx )
        {
            // vZXIuWFNg̃nh擾
            HANDLE hProcess;
            hProcess = OpenProcess(
                    PROCESS_QUERY_INFORMATION | PROCESS_VM_READ,
                    FALSE, dwProcessId);
            if ( hProcess )
            {
                // .EXE W[̃nh擾
                HMODULE hModule;
                DWORD dwNeed;
                if (lpfEnumProcessModules(hProcess,
                            &hModule, sizeof(hModule), &dwNeed))
                {
                    // W[nhtpX擾
                    if ( lpfGetModuleFileNameEx(hProcess, hModule,
                                            lpszFileName, nSize) )
                        bResult = TRUE;
                }
                // vZXIuWFNg̃nhN[Y
                CloseHandle( hProcess ) ;
            }
        }
        // PSAPI.DLL CuJ
        FreeLibrary( hInstLib ) ;
    }
    // vbgtH[ Windows 9x ̏ꍇ
    else if ( osverinfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS )
    {
        // ToolHelp ֐|C^
        HANDLE (WINAPI *lpfCreateSnapshot)(DWORD, DWORD);
        BOOL (WINAPI *lpfProcess32First)(HANDLE, LPPROCESSENTRY32);
        BOOL (WINAPI *lpfProcess32Next)(HANDLE, LPPROCESSENTRY32);

        // vV[W̃AhX擾
        lpfCreateSnapshot =
            (HANDLE(WINAPI*)(DWORD,DWORD))GetProcAddress(
                                GetModuleHandle("kernel32.dll"),
                                "CreateToolhelp32Snapshot" );
        lpfProcess32First=
            (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32))GetProcAddress(
                                GetModuleHandle("kernel32.dll"),
                                "Process32First" );
        lpfProcess32Next=
            (BOOL(WINAPI*)(HANDLE,LPPROCESSENTRY32))GetProcAddress(
                                GetModuleHandle("kernel32.dll"),
                                "Process32Next" );
        if ( !lpfCreateSnapshot ||
            !lpfProcess32First ||
            !lpfProcess32Next)
            return FALSE;

        // VXe vZX Toolhelp XibvVbg쐬
        HANDLE hSnapshot;
        hSnapshot = lpfCreateSnapshot(TH32CS_SNAPPROCESS , 0);
        if (hSnapshot != (HANDLE)-1)
        {
            // ŏ̃vZXɊւ擾
            PROCESSENTRY32 pe;
            pe.dwSize = sizeof(PROCESSENTRY32);
            if ( lpfProcess32First(hSnapshot, &pe) )
            {
                do {
                    // vZXID ł΁At@C擾
                    if (pe.th32ProcessID == dwProcessId)
                    {
                        lstrcpy(lpszFileName, pe.szExeFile);
                        bResult = TRUE;
                        break;
                    }
                } while ( lpfProcess32Next(hSnapshot, &pe) );
            }
            // XibvVbgj
            CloseHandle(hSnapshot);
        }
    }
    else
        return FALSE;
    GetLongPathName(lpszFileName, lpszFileName, nSize);
    return bResult;
}

char *set_my_path(char *path, char *fname)
{
    int nLen = GetModuleFileName(g_PI->hInstance, path, MAX_PATH);
    while (nLen && path[nLen-1] != '\\') nLen--;
    strcpy(path+nLen, fname);
    return path;
}
//===========================================================================
